<!DOCTYPE html>
<html lang="en">

<head>
  <meta charset="UTF-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>Quiz</title>

  <style type="text/css">
    body {
      margin: 0;
      font-family: Arial, Helvetica, sans-serif;
    }

    .main {
      width: 100%;
      max-width: 40rem;
      border: thin solid black;
      margin: 8px auto;
      padding: 1.5rem 2.5rem;
      box-sizing: border-box;
    }

    .form-group {
      position: relative;
      margin-bottom: 1.5rem;
    }

    .label {
      display: inline-block;
      width: 100%;
      max-width: 5rem;
      font-weight: bold;
    }

    input,
    select {
      font-size: larger;
    }

    .display {
      border: thin solid black;
      min-height: 20rem;
      text-align: center;
      font-weight: bold;
    }
  </style>
</head>

<body>
  <main class="main">
    <form id="form1">
      <div class="form-group">
        <label class="label">List</label>
        <input id="txtList" type="text" style="width: calc(100% - 6rem);">
      </div>
      <div class="form-group">
        <label class="label">ค้นหา</label>
        <input id="txtSearch" type="search">
        <input id="btnSubmit" type="submit" style="font-size: large;" value="ค้นหา">
      </div>
      <div class="form-group" style="text-align: center;">
        <label class="label" style="width: none; max-width: none;">ประเภทการค้นหา</label>
        <select id="selectAlgorithm" style="width: 20rem; text-align-last: center;">
          <option value="linear">1. Linear Search</option>
          <option value="binary">2. Binary Search</option>
          <option value="bubble">3. bumble Search</option>
        </select>
      </div>
    </form>
    <div>
      <label class="label">ผลลัพธ์</label>
      <div class="display" id="display">
      </div>
    </div>
  </main>
  <script type="text/javascript">

    function bubbleSort(_list) {
      var list = [..._list];
      var n = list.length;
      var swapped = false;
      do {
        swapped = false;
        for (var i = 1; i <= n - 1; i++) {
          if (list[i - 1] > list[i]) {
            var temp = list[i - 1];
            list[i - 1] = list[i];
            list[i] = temp;
            swapped = true;
          }
        }
        n = n - 1;
      } while (swapped);
      return list;
    };

    function linearSearch(list, target, progress, callback) {
      var found = false;
      for (var i = 0; i < list.length; i++) {
        found = list[i] === target;
        progress(found, i + 1, target, list[i]);
        if (found) {
          break;
        }
      }
      if (typeof callback === 'function')
        callback(null, found)
    }

    function binarySearch(_list, target, progress, callback) {
      var list = bubbleSort(_list);
      var found = false;
      var start = 0;
      var ending = list.length - 1;
      var round = 1;

      while (start <= ending) {
        var mid = Math.round((start + ending) / 2);

        if (target < list[mid]) {
          ending = mid - 1;
        } else if (target > list[mid]) {
          start = mid + 1;
        } else {
          found = true;
        }

        progress(found, round, target, list[mid]);

        if (found)
          break;
        else
          round++;
      }
      if (typeof callback === 'function')
        callback(null, found);
    }

    function bubbleSearch(list, target, progress, callback) {
      if (callback) {
        var message = 'T29wcyEgSSBkb24ndCBrbm93IGFib3V0ICJCdWJibGUgU2VhcmNoIiBhbGdvcml0aG0u';
        callback(new Error(atob(message)));
      }
    }
    function doSearch(list, search, algorithmName) {
      display.innerHTML = null;
      var algorithms = {
        linear: linearSearch,
        binary: binarySearch,
        bubble: bubbleSearch,
      };

      var p1 = document.createElement('p');
      p1.innerText = 'List : [ ' + list.join(', ') + ' ]';
      var p2 = document.createElement('p');
      p2.innerText = 'Search : ' + search;
      var p3 = document.createElement('p');
      p3.innerText = 'Result :::';
      display.append(p1, p2, p3);

      var fn = algorithms[algorithmName];
      fn(list, search,
        function (found, round, target, item) {
          var sign = found ? '=' : '!=';
          var p = document.createElement('p');
          p.innerText = 'Round : ' + round + ' ===> ' + target + ' ' + sign + ' ' + item;
          display.append(p);
        },

        /**
        * @param err {Error}
        * @param found {boolean}
        */
        function (err, found) {
          if (err) {
            var p = document.createElement('p');
            p.style.fontSize = 'larger';
            p.style.color = 'red';
            p.innerText = err.message;
            display.append(p);
          } else if (found) {
            var span = document.createElement('span');
            span.innerText = ' found !!';
            display.lastElementChild.append(span);
          } else {
            var p = document.createElement('p');
            p.innerText = 'Not found !!';
            display.append(p);
          }
        });

    }

    var form1 = document.getElementById('form1');
    var display = document.getElementById('display');
    form1.addEventListener('submit', function (ev) {
      ev.preventDefault();
      if (!(form1.txtList.value || '').trim())
        return false;
      var list = form1.txtList.value
        .split(',')
        .map(function (value) {
          return parseFloat(value)
        });

      if (!(form1.txtSearch.value || '').trim())
        return false;
      var search = parseFloat(form1.txtSearch.value);
      if (isNaN(search))
        return false;
      var algorithmName = form1.selectAlgorithm.value;
      doSearch(list, search, algorithmName);
    });

    // example list : 9, 1, 6, 2, 4, 10, 8, 7, 5, 3
  </script>
</body>

</html>